/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"time"

	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	scheme "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/generated/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// V3DeploymentsGetter has a method to return a V3DeploymentInterface.
// A group's client should implement this interface.
type V3DeploymentsGetter interface {
	V3Deployments(namespace string) V3DeploymentInterface
}

// V3DeploymentInterface has methods to work with V3Deployment resources.
type V3DeploymentInterface interface {
	Create(*v1.V3Deployment) (*v1.V3Deployment, error)
	Update(*v1.V3Deployment) (*v1.V3Deployment, error)
	Delete(name string, options *metav1.DeleteOptions) error
	DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error
	Get(name string, options metav1.GetOptions) (*v1.V3Deployment, error)
	List(opts metav1.ListOptions) (*v1.V3DeploymentList, error)
	Watch(opts metav1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.V3Deployment, err error)
	V3DeploymentExpansion
}

// v3Deployments implements V3DeploymentInterface
type v3Deployments struct {
	client rest.Interface
	ns     string
}

// newV3Deployments returns a V3Deployments
func newV3Deployments(c *KumoriV1Client, namespace string) *v3Deployments {
	return &v3Deployments{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the v3Deployment, and returns the corresponding v3Deployment object, and an error if there is any.
func (c *v3Deployments) Get(name string, options metav1.GetOptions) (result *v1.V3Deployment, err error) {
	result = &v1.V3Deployment{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("v3deployments").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of V3Deployments that match those selectors.
func (c *v3Deployments) List(opts metav1.ListOptions) (result *v1.V3DeploymentList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.V3DeploymentList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("v3deployments").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested v3Deployments.
func (c *v3Deployments) Watch(opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("v3deployments").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a v3Deployment and creates it.  Returns the server's representation of the v3Deployment, and an error, if there is any.
func (c *v3Deployments) Create(v3Deployment *v1.V3Deployment) (result *v1.V3Deployment, err error) {
	result = &v1.V3Deployment{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("v3deployments").
		Body(v3Deployment).
		Do().
		Into(result)
	return
}

// Update takes the representation of a v3Deployment and updates it. Returns the server's representation of the v3Deployment, and an error, if there is any.
func (c *v3Deployments) Update(v3Deployment *v1.V3Deployment) (result *v1.V3Deployment, err error) {
	result = &v1.V3Deployment{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("v3deployments").
		Name(v3Deployment.Name).
		Body(v3Deployment).
		Do().
		Into(result)
	return
}

// Delete takes name of the v3Deployment and deletes it. Returns an error if one occurs.
func (c *v3Deployments) Delete(name string, options *metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("v3deployments").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *v3Deployments) DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("v3deployments").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched v3Deployment.
func (c *v3Deployments) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.V3Deployment, err error) {
	result = &v1.V3Deployment{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("v3deployments").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
